﻿using System;
using System.Collections.Generic;
using Foundation;
using Shinobi.Charts;

namespace MyChartApp
{
    public class ChartDataModel : SChartDataSource
    {
        private List<SChartDataPoint>mItems;
        private List<SChartDataPoint> mDigitalItems;

        public ChartDataModel()
        {
            mItems = new List<SChartDataPoint>();
            mDigitalItems = new List<SChartDataPoint>();

            for (int i = 0; i < 10; i++)
            {
                AddRandomValuesToChartModels();
            }
        }

        public void AddDataToChartModel(int value)
        {
            mItems.Add(new SChartDataPoint(FromObject(mItems.Count + 1), FromObject(value)));
        }

        public void AddDataToDigitalChartModel(int value)
        {
            mDigitalItems.Add(new SChartDataPoint(FromObject(mDigitalItems.Count + 1), FromObject(value)));
            //mDigitalItems.Add(new SChartDataPoint(FromObject(mDigitalItems.Count + 1), (value < 10) ? NSNull.Null : FromObject(1)));
        }

        public void AddRandomValuesToChartModels()
        {
            Random rand = new Random();

            AddDataToChartModel(rand.Next(0, 20));
            AddDataToDigitalChartModel(rand.Next(0, 20));
        }

        public override ISChartData GetDataPoint(ShinobiChart chart, nint dataIndex, nint seriesIndex)
        {
            if (seriesIndex == 0)
            {
                return mItems[(int)dataIndex];
            }
            else if (seriesIndex == 1)
            {
                return mDigitalItems[(int)dataIndex]; 
            }

            return null;
        }

        public override nint GetNumberOfDataPoints(ShinobiChart chart, nint seriesIndex)
        {
            return mItems.Count;
        }

        public override nint GetNumberOfSeries(ShinobiChart chart)
        {
            return 2;
        }

        public override SChartSeries GetSeries(ShinobiChart chart, nint index)
        {
            SChartSeries series = null;

            if (index == 0)
            {
                series = new SChartLineSeries();
                series.Title = "Signal A";
            }
            else if (index == 1)
            {
                series = new SChartLineSeries();
                series.Title = "Signal B";
            }

            return series;
        }
    }
}
