﻿using System;
using System.Collections.Generic;
using Foundation;
using Syncfusion.SfChart.iOS;

namespace MyChartApp
{
	public class ChartDataSource : SFChartDataSource
	{
		NSMutableArray DataPoints;

		public ChartDataSource()
		{
			DataPoints = new NSMutableArray();
			AddDataPointsForChart("Product A", 14);
			AddDataPointsForChart("Product B", 54);
			AddDataPointsForChart("Product C", 23);
			AddDataPointsForChart("Product D", 53);
		}

		void AddDataPointsForChart(String month, Double value)
		{
			DataPoints.Add(new SFChartDataPoint(NSObject.FromObject(month), NSObject.FromObject(value)));
		}

		public override nint NumberOfSeriesInChart(SFChart chart)
		{
			return 1;
		}

		public override SFSeries GetSeries(SFChart chart, nint index)
		{
			SFDoughnutSeries series = new SFDoughnutSeries();
			series.StartAngle = 180;
			series.EndAngle = 360;
			series.CircularCoefficient = 1f;
			series.DataMarker.ShowLabel = true;
			series.DataMarker.LabelContent = SFChartLabelContent.Percentage;
			series.DataMarkerPosition = SFChartCircularSeriesLabelPosition.Outside;
			series.EnableAnimation = true;
			return series;
		}

		public override SFChartDataPoint GetDataPoint(SFChart chart, nint index, nint seriesIndex)
		{
			return DataPoints.GetItem<SFChartDataPoint>((nuint)index);//returns the datapoint for each series.
		}

		public override nint GetNumberOfDataPoints(SFChart chart, nint index)
		{
			return (int)DataPoints.Count;//No of datapoints needed for each serie.
		}
	}
}
